;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                              ;;
;; Copyright (C) KolibriOS team 2013. All rights reserved.      ;;
;; Distributed under terms of the GNU General Public License    ;;
;;                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

$Revision: 3240 $


f70struct:
f70func: dd 0 ; func
f70pos: dd 0 ; file pos
dd 0 ; reserved
f70bytes: dd 0 ; bytes to read
f70pointer: dd 0 ; pointer to read data
db 0 ; ASCIIZ-pointer used
f70name: dd 0 ; pointer to path

;SYS0
unix_malloc:

stdcall user_alloc_at, ebx, ecx
DEBUGF  1, "K : Get alloc at: %x\n", eax
mov [esp+32], eax
ret

;SYS1
unix_exit:

call sys_end
ret

;SYS3
unix_read:
cmp ebx, 101
jne skip_read

mov [f70func], dword 0
mov [f70pointer], ecx
mov [f70bytes], edx
mov ebx, f70func
call file_system_lfn


mov edx, [f70pos]
add edx, [f70bytes]
mov [f70pos], edx

mov [esp+32], ebx
skip_read:
DEBUGF 1, "K : SYS4 FD call, bytes read %d from file pos %d\n", f70bytes, f70pos
ret

;SYS4
unix_write:
;ebx = 1 - stdout
;ecx = msg pointer
;edx = len

mov al, byte [ecx]
call fdo_debug_outchar  ;1, "%s", ecx
inc ecx
dec edx 
jnz unix_write
ret

;SYS5
unix_open:
mov [f70name], ebx
mov eax, 101
mov [esp+32], eax
ret

;SYS6
unix_close:
mov [f70name], dword 0
mov [f70pos], dword 0
mov [f70bytes], dword 0
ret

;SYS13
unix_time:
mov [ebx], dword 1
ret


;SYS183
unix_getcwd:
mov edx, ecx
mov ecx, ebx
mov ebx, 2
mov eax, 183
call sys_current_directory
ret

