; Copyright (c) 2009, <Lrz>
; All rights reserved.
;
; Redistribution and use in source and binary forms, with or without
; modification, are permitted provided that the following conditions are met:
;       * Redistributions of source code must retain the above copyright
;       notice, this list of conditions and the following disclaimer.
;       * Redistributions in binary form must reproduce the above copyright
;       notice, this list of conditions and the following disclaimer in the
;       documentation and/or other materials provided with the distribution.
;       * Neither the name of the <organization> nor the
;       names of its contributors may be used to endorse or promote products
;       derived from this software without specific prior written permission.
;
; THIS SOFTWARE IS PROVIDED BY Alexey Teplov nickname <Lrz> ''AS IS'' AND ANY
; EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
; WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
; DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY
; DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
; (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
; ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;*****************************************************************************

;            point_default
;    
; RamdiskFS
;/     
ATTR_READ_ONLY  equ     0x01
ATTR_HIDDEN     equ     0x02
ATTR_SYSTEM     equ     0x04
ATTR_VOLUME_ID  equ     0x08
ATTR_DIRECTORY  equ     0x10
ATTR_ARCHIVE    equ     0x20



show_error_1    equ     0x1     ;  -    
show_error_2    equ     0x2     ;      .
show_error_3    equ     0x4     ;      =64 . 
show_error_4    equ     0x8     ;

macro use_parse_def_sect
{
        mov     di, point_default
        push    ini_data_
        pop     es
        mov     si, point_to_point_def
        sub     si, 2
        mov     cx, [si]        ;   

        xor     ax, ax  ; x     

        sub     cx, di          ;    
        mov     save_cx_d, cx   ;  cx  
;  ,  ,  ,      

        mov     status_flag, ax
;;;;
;     . es:di -     cx     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   bp, es, cs, sp         
;use_Loader_Image       ;   1 
use_RamdiskFS
;  .
use_LoaderModule    ; -     .
}

macro use_LoaderModule
;    ,       ,  
;        
{
local .found_end_str

        mov     di, point_default  ;restore value
        mov     cx, save_cx_d
;   LoaderModule=kord/kolibri.ldm
.start_p_LM:
        call    get_firs_sym    ;get first symbol on new line
        test    cx, cx
        jz      ._afterLoaderModule     ;?   -    ) 
        cmp     al, 'L'
        jnz     .start_p_LM
;   LoaderModule
;        parse_LoaderModule
        mov     bx, cx
        mov     ax, di

        mov     si, parse_LoaderModule
        mov     cx, parse_LoaderModule_e - parse_LoaderModule
        repe cmpsb
        jnz     .rest_value_loop_LM        ;is not compare

        sub     bx, parse_LoaderModule_e - parse_LoaderModule;correct cx
        add     bx, cx
        mov     cx, bx

        test    status_flag, flag_found_LM              ; 
        jz      .correct_is_not_set_LM

;       mov     si,found_equal_timeout                          ;     , 
;       call    printplain
;       jmp     .get_next_str

.correct_is_not_set_LM:
        mov     ax, 0x3d20         ;cut al=' ' ah='='
        repe scasb
        jcxz    .rest_value_loop_LM          ;not found param timeout
        
        cmp     ah, byte [es:di-1]   ;find '='
        jnz     .rest_value_loop_LM
        
        repe scasb                 ;cut ' '
        inc     cx
        dec     di
;di     ,  cx    .
;     .
;     ,  callback 
;  -  dd       byte =0
;  :  ini    LoaderModule = kord/kernel.loader
;            dw,dw,db'kord/kernel.loader',0       
;  2 word
        push    dword [es:di-6]
        lea     si, [di-6]

        push    word [es:di-2]
        xor     ax, ax
        mov     word [es:di-6], ax      ;  
;info_real_mode_size         
        mov     ax, info_real_mode_size ;0x3000   ;   


        mov     word [es:di-4], ax
        mov     word [es:di-2], 16      ;-   4  =64  ..    
;;;;;;   
@@:
        mov     al, byte [es:di]
        cmp     al, ' '
        jz      .found_end_str
        cmp     al, 0xa
        jz      .found_end_str
        cmp     al, 0xd
        jz      .found_end_str
        inc     di
        dec     cx
        jnz     @b
;;;not found ,          
.found_end_str:

        push    word [es:di]
        xor     ax, ax
        mov     word [es:di], ax
;        xor     ax,ax   ; function 1 - read file
        mov     di, si  ;file_data
        inc     ax
        push    si
        push    es

        push    es
        pop     ds
        push    cs
        pop     es

        call    far dword [es:loader_callback]

        push    cs
        pop     ds

        pop     es
        pop     si

        test    bx, bx
        jnz     .error_LM


        jmp     far dword [es:si]


.error_LM:
        call    error.LoaderModule
.rest_value_loop_LM:
        mov     di, ax
        mov     cx, bx
        jmp     .start_p_LM

._afterLoaderModule:
}

macro use_RamdiskFS
;   , +   .
{
if DEBUG
local ._not_memory_in_sys
;//////// clear window
        mov     ax, 3
        int     0x10
;\\\\\\\\\ clear window is end
        mov     si, ramdiskFS_st
        call    printplain
end if
;    
        xor     ax, ax
        mov     show_errors_sect, ax
use_free_memory ;       .    ax
;              .
use_RamdiskSize ;   bx
        cmp     free_ad_memory, bx      ;   .
        jbe     ._not_memory_in_sys
        movzx   eax, bx
        shl     eax, 10 ;*1024 = get size in byte
        mov     save_ramdisksize, eax   ;    byte

get_type_FS     ;    +   

        
._not_memory_in_sys:
        
if DEBUG
;pause
        xor     ax, ax
        int     0x16
end if
}
macro use_RamdiskSize
{
local .start_p_RS
local .correct_is_not_set_RS
local .CS
local .correct_val_RS
local .correct_size_RS
local .rest_value_loop_RS
local .end_get_RS_ERROR_1
local .end_get_RS_ERROR_2
local ._end_parse_RS
;    
;  , ..       
        mov     di, point_default  ;restore value
        mov     cx, save_cx_d
.start_p_RS:
        call    get_firs_sym    ;get first symbol on new line
        test    cx, cx
        jz      ._end_parse_RS  ;?   -    ) 
        cmp     al, 'R'
        jnz     .start_p_RS
;   RamdiskSize
;        parse_RamdiskSize
        mov     bx, cx
        mov     ax, di

        mov     si, parse_RamdiskSize
        mov     cx, parse_RamdiskSize_e - parse_RamdiskSize
        repe cmpsb
        jnz     .rest_value_loop_RS    ;is not compare

        sub     bx, parse_RamdiskSize_e - parse_RamdiskSize;correct cx
        add     bx, cx
        mov     cx, bx

        test    status_flag, flag_found_RS              ; 
        jz      .correct_is_not_set_RS

;       mov     si,found_equal_timeout                          ;     , 
;       call    printplain
;       jmp     .get_next_str

.correct_is_not_set_RS:
        mov     ax, 0x3d20         ;cut al=' ' ah='='
        repe scasb
        jcxz    .end_get_RS_ERROR_1          ;not found param 
        
        cmp     ah, byte [es:di-1]   ;find '='
        jnz     .start_p_RS                     ;         
        
        repe scasb                 ;cut ' '
        inc     cx
        dec     di
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      .
;;;;;;;;;;;;;;;;;;;;;;;;;;
        xor     bx, bx
        mov     cx, 5
@@:
        mov     al, byte [es:di]
        cmp     al, '0'
        jb      .CS
        cmp     al, '9'
        jbe     .correct_val_RS
.CS:
        cmp     al, 'K'
        jz      .correct_size_RS
        jmp     .end_get_RS_ERROR_2
.correct_val_RS:        
        imul    bx, 10
        xor     al, 0x30
        add     bl, al
        inc     di
        loop    @b

.correct_size_RS:
; 1 ,     K 
;    -    .
        test    bx, bx
        jnz     @f      ;    0
;;;;;  ,  ""  =0   
; 64    .
        or      show_errors_sect, show_error_3
        mov     bx, 64
@@:
        jmp     ._end_parse_RS


.rest_value_loop_RS:
        mov     di, ax
        mov     cx, bx
        jmp     .start_p_RS
        
        
        
.end_get_RS_ERROR_1:
;   -        :(
        or      show_errors_sect, show_error_1
        jmp     ._end_parse_RS
.end_get_RS_ERROR_2:    
        or      show_errors_sect, show_error_2

._end_parse_RS:
if DEBUG
        pusha
        movzx   eax, bx
        mov     cx, 0x0a
        mov     di, RamdiskSize_msg
        mov     dword[ds:di], '    '
        mov     word [ds:di+4], '  '
        call    decode
;Show size
        mov     si, RamdiskSize_msg
        call    printplain

        popa
end if  

}

macro use_free_memory
{       
local _support_function_use_free_memory
;        ,       1 .
; 088  015 
;   ,   ax   ,  ,   ax=0
        mov     ah, 0x88 ;ah,0x88
        int     0x15
        jnc     ._support_function_use_free_memory
        xor     ax, ax
;  ax    
._support_function_use_free_memory:
        mov     free_ad_memory, ax ;    ,   ax=0
if DEBUG
        pushad
        movzx   eax, ax
        mov     cx, 0x0a
        mov     di, free_memory_msg
        mov     dword[ds:di], '    '
        mov     word [ds:di+4], '  '
        call    decode
;Show size
        mov     si, free_memory_msg
        call    printplain

        popad
end if  




}
macro show_ERRORS
{

}

macro get_type_FS ;      RFS.
{
        mov     di, point_default  ;restore value
        mov     cx, save_cx_d
.start_g_tpe_RFS:
        call    get_firs_sym    ;get first symbol on new line
        test    cx, cx
        jz      ._end_parse_FRS ;._end_get_type_RFS     ;?   -    ) 
        cmp     al, 'R'
        jnz     .start_g_tpe_RFS
;   RamdiskSize
;        parse_RamdiskSize
        mov     bx, cx
        mov     ax, di

        mov     si, parse_RamdiskFS
        mov     cx, parse_RamdiskFS_e - parse_RamdiskFS
        repe cmpsb
        jnz     .start_g_tpe_RFS_rest_v    ;is not compare

        sub     bx, parse_RamdiskFS_e - parse_RamdiskFS;correct cx
        add     bx, cx
        mov     cx, bx

        test    status_flag, flag_found_GTRFMS          ; 
        jz      .correct_is_not_set_FRS

;       mov     si,found_equal_timeout                          ;     , 
;       call    printplain
;       jmp     .get_next_str

.correct_is_not_set_FRS:
        mov     ax, 0x3d20         ;cut al=' ' ah='='
        repe scasb
        test    cx, cx
        jz      .end_get_FRS_ERROR_1          ;not found param 
        
        cmp     ah, byte [es:di-1]   ;find '='
        jnz     .start_g_tpe_RFS                        ;         
        
        repe scasb                 ;cut ' '
        inc     cx
        dec     di
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      .
;;;;;;;;;;;;;;;;;;;;;;;;;;
        mov     bx, cx
        mov     ax, di

        mov     si, parse_RFS_FAT
        mov     cx, parse_RFS_FAT_e - parse_RFS_FAT
        repe cmpsb
        jnz     .krfs_cmp          ;is not compare

make_FAT_RamFS  ; 

if DEBUG
        pusha
        mov     si, make_fat12_RFS_msg
        call    printplain
        popa
end if  
        jmp     ._end_parse_FRS

.krfs_cmp:              
        mov     cx, bx
        mov     di, ax

        mov     si, parse_RFS_KRFS
        mov     cx, parse_RFS_KRFS_e - parse_RFS_KRFS
        repe cmpsb
;       jnz     @f         ;is not compare

        jmp     ._end_parse_FRS


.start_g_tpe_RFS_rest_v:
        mov     cx, bx
        mov     di, ax
        jmp     .start_g_tpe_RFS
        
        
        
.end_get_FRS_ERROR_1:
;   -        :(
        or      show_errors_sect, show_error_1
        jmp     ._end_parse_FRS
.end_get_FRS_ERROR_2:   
        or      show_errors_sect, show_error_2

._end_parse_FRS:
if DEBUG
        pusha
        mov     si, get_type_FS_msg
        call    printplain
        popa
end if  



}
macro make_FAT_RamFS
{
local .RS1
local .fat12
local .fat16
;       Ram FS,        1 ..
;   FAT12
;       mov     di,fat12_buffer ;ds   = cs
;es:di -        .
use_RamdiskSector       ;   ax    
        cmp     ax, 4096;        1  4096
        ja      .RS1
        test    ax, ax
        jnz     @f      ;      ... 

.RS1:
        mov     word [fat12_buffer.BPB_BytsPerSec], 512
;;;;;;;;;;      ... 
@@:
        mov     word [fat12_buffer.BPB_BytsPerSec], ax;  

;BPB_SecPerClus -   
use_RamdiskCluster      ;   al
        cmp     al, 128
        ja      @f
;       test    al,0x1  ;   ) 
;       jnz     @f

        mov     byte [fat12_buffer.BPB_SecPerClus], al

        ;incorrect value will be set dafault

;    ..   2     1  128 
;      
;@@:    ;mov    byte [fat12_buffer.BPB_SecPerClus],1    

;;;;;       FAT 
; , fat12<4085<=fat16<65525<=fat32
; fat12_buffer.BPB_BytsPerSec*fat12_buffer.BPB_SecPerClus = - 
        movzx   eax, word [fat12_buffer.BPB_BytsPerSec]
        movzx   ebx, byte [fat12_buffer.BPB_SecPerClus]

        imul    ebx, eax;   
        mov     eax, save_ramdisksize ;     
        cdq
        idiv    ebx
;;;;;;;;    eax,    edx
; - ,      FAT   .
        cmp     eax, 4085
        jb      .fat12
        cmp     eax, 65525
        jb      .fat16
;;;;;;;;;;;;;;;;;;;;;;;;  fat32
        mov     set_ramfs, 32   ;   
        mov     word [fat12_buffer.BPB_RsvdSecCnt], 32
        xor     eax, eax
        mov     word [fat12_buffer.BPB_RootEntCnt], ax
        mov     word [fat12_buffer.BPB_TotSec16], ax
        mov     dword [fat12_buffer.BPB_TotSec32], eax


.fat16: ;fat16
; FAT12  FAT16      ,  BPB_TotSec32  0,   <> ( 0x10000).
        jmp     $
        mov     set_ramfs, 16   ;   
        movzx   ebx, byte [fat12_buffer.BPB_SecPerClus]
        imul    eax, ebx

        cmp     eax, 0x10000
        jae     @f
        mov     word [fat12_buffer.BPB_TotSec16], ax
        mov     dword [fat12_buffer.BPB_TotSec32], 0
@@:
;     
;       mov     word [fat12_buffer.BPB_FATSz16],0x9     ; FAT12/FAT16     FAT. ??
;;;;  BPB_RootEntCnt  FAT12  FAT16 ,    
;32-   .  FAT32 ,   
; 0.  ,    . 
        mov     eax, root_dir_entry_count
        mov     word [fat12_buffer.BPB_RootEntCnt], ax  ; count of 32-byte dir. entries (224*32 = 14 sectors= 7 kb)
;    16        ,   .      7 
;;;;;;;
; FAT16     FAT.  FAT32  
; 0,     FAT   BPB_FATSz32.
;RootDirSectors = ((BPB_RootEntCnt * 32) + (BPB_BytsPerSec - 1)) / BPB_BytsPerSec;

;TmpVal1 = DskSize - (BPB_ResvdSecCnt + RootDirSectors);
;TmpVal2 = (256 * BPB_SecPerClus) + BPB_NumFATs;
;If(FATType == FAT32)
;    TmpVal2 = TmpVal2 / 2;
;FATSz = (TMPVal1 + (TmpVal2 - 1)) / TmpVal2;
;If(FATType == FAT32) {
;    BPB_FATSz16 = 0;
;    BPB_FATSz32 = FATSz;
;} else {
;    BPB_FATSz16 = LOWORD(FATSz);
;    /* there is no BPB_FATSz32 in a FAT16 BPB */
;}
;=====================================
;RootDirSectors
        movzx   ebx, word [fat12_buffer.BPB_BytsPerSec]
        imul    eax, 32
        add     eax, ebx
        dec     eax

        cdq
        idiv    ebx
;;;;;;;;    eax,    edx   1.44      =14
;BPB_ResvdSecCnt + RootDirSectors
        movzx   ebx, word [fat12_buffer.BPB_RsvdSecCnt]
        add     ebx, eax
         
;DskSize         
        movzx   eax, word [fat12_buffer.BPB_TotSec16]   ;   
        sub     eax, ebx


;TmpVal1=eax
        shl     edi, 8  ;=edi*256
        movzx   ecx, byte [fat12_buffer.BPB_NumFATs]
        add     edi, ecx
;TmpVal2=edi
        add     eax, edi
        dec     eax
        cdq
        idiv    edi
;FATSz =    eax,    edx
        mov     word [fat12_buffer.BPB_FATSz16], ax








.fat12: ;fat12
if DEBUG
;   ,      c FS=fat12
        pushad
        mov     si, start_making_FAT12_msg
        call    printplain
        popad
end if



; FAT12  FAT16      ,  BPB_TotSec32  0,   <> ( 0x10000).
        mov     set_ramfs, 12   ;   
        movzx   ebx, byte [fat12_buffer.BPB_SecPerClus]
        imul    eax, ebx

        cmp     eax, 0x10000
        jae     @f
        mov     word [fat12_buffer.BPB_TotSec16], ax
        mov     dword [fat12_buffer.BPB_TotSec32], 0
@@:
;     
;       mov     word [fat12_buffer.BPB_FATSz16],0x9     ; FAT12/FAT16     FAT. ??
;;;;  BPB_RootEntCnt  FAT12  FAT16 ,    
;32-   .  FAT32 ,   
; 0.  ,    . 
        mov     eax, root_dir_entry_count
        mov     word [fat12_buffer.BPB_RootEntCnt], ax  ; count of 32-byte dir. entries (224*32 = 14 sectors= 7 kb)
;    16        ,   .      7 
;;;;;;;
;DskSize( )*12 (  , .        ) /8 (    )
;        .. 512     ,   
;      ,           12
        movzx   eax, word [fat12_buffer.BPB_TotSec16]
        imul    eax, 12
        shr     eax, 3  ;  8  ..       512       
        movzx   ebx, word [fat12_buffer.BPB_BytsPerSec] ; 
        cdq
        idiv    ebx     ;   
;    eax         512 
;   and   512 .     512 
; ..        
;       and     eax,0xfff200
;       add     eax,0x200       ; 512          1.44    ))  

        inc     ax
;      
; 9  ..  2*9=18+1 =19  ..      20  ..   02600
;        )    512
;FATSz =    eax
        mov     word [fat12_buffer.BPB_FATSz16], ax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_firstDataSector ;    
;       .
first_create_fat_table
; BPB    1 .
use_BPB_RAM
;
; .
use_RamdiskFile

;;;;      FirstRootDirSecNum = BPB_ResvdSecCnt + (BPB_NumFATs * BPB_FATSz16);
;       movzx   ebx, [fat12_buffer.BPB_NumFATs]
;       movzx   eax,ax
;       imul    eax,ebx
;eax=(BPB_NumFATs * BPB_FATSz16)
;       inc     eax
; BPB_ResvdSecCnt   1  fat12/16
; eax   root dir.   fat12    -  fat 1  = 1+ (1*1) =2  3

if DEBUG        
        pusha
;       mov     ax,point_default
;        mov     ax,cx
        mov     cx, 0x0a
        mov     di, show_db1
;        mov     dword[ds:di],'    '
;       mov     word [ds:di+4],'  '
        call    decode
;Show size
        mov     si, show_db1
        call    printplain
;
;       xor     ax,ax
;       int     0x16
        popa
end if  







}

macro use_RamdiskSector
{
;  FS   
        mov     di, point_default  ;restore value
        mov     cx, save_cx_d

.start_RamdiskSector:
        call    get_firs_sym    ;get first symbol on new line
        test    cx, cx
        jz      .end_RamdiskSector      ;?   -    ) 

        cmp     al, 'R'
        jnz     .start_RamdiskSector
;   RamdiskSize
;        parse_RamdiskSize

        mov     bx, cx
        mov     ax, di

        mov     si, parse_RamdiskSector
        mov     cx, parse_RamdiskSector_e - parse_RamdiskSector
        repe cmpsb
        jnz     .RamdiskSector_rest_val    ;is not compare

        sub     bx, parse_RamdiskSector_e - parse_RamdiskSector;correct cx
        add     bx, cx
        mov     cx, bx

        test    status_flag, flag_found_RamdiskSector           ; 
        jz      .correct_is_not_set_RamdiskSector

;       mov     si,found_equal_timeout                          ;     , 
;       call    printplain
;       jmp     .get_next_str

.correct_is_not_set_RamdiskSector:
        mov     ax, 0x3d20         ;cut al=' ' ah='='
        repe scasb
        jcxz    .end_get_RamS_ERROR_1          ;not found param 
        
        cmp     ah, byte [es:di-1]   ;find '='
        jnz     .start_RamdiskSector                    ;         
        
        repe scasb                 ;cut ' '
        inc     cx
        dec     di
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        xor     bx, bx
        mov     cx, 4
@@:
        movzx   ax, byte [es:di]
        cmp     al, '0'
        jb      .end_RamdiskSector
        cmp     al, '9'
        ja      .end_RamdiskSector
;;;;;;;;;;;;;;;;;;;

        imul    bx, 10
        xor     al, 0x30
        add     bx, ax

        inc     di

        loop    @b
        jmp     .end_RamdiskSector


.RamdiskSector_rest_val:
        mov     cx, bx
        mov     di, ax
        jmp     .start_RamdiskSector
.end_get_RamS_ERROR_1:

.end_RamdiskSector:
        mov     ax, bx

if DEBUG
        pusha
        movzx   eax, bx;save_cx_d;point_default
        mov     cx, 0x0a
        mov     di, RamdiskSector_msg
        mov     dword[ds:di], '    '
        mov     dword [ds:di+4], '    '
        call    decode
;Show size
        mov     si, RamdiskSector_msg
        call    printplain

        popa
end if  

;       pop     di
;       pop     es
}

macro use_RamdiskCluster
{
;  FS   
;       push    es
;       push    di
        mov     di, point_default  ;restore value
        mov     cx, save_cx_d
;       push    ini_data_
;       pop     es
.start_RamdiskCluster:
        call    get_firs_sym    ;get first symbol on new line
        test    cx, cx
        jz      .end_RamdiskCluster     ;?   -    ) 
        cmp     al, 'R'
        jnz     .start_RamdiskCluster
;   RamdiskSize
;        parse_RamdiskSize

        mov     bx, cx
        mov     ax, di

        mov     si, parse_RamdiskCluster
        mov     cx, parse_RamdiskCluster_e - parse_RamdiskCluster
        repe cmpsb
        jnz     .RamdiskCluster_rest_val           ;is not compare

        sub     bx, parse_RamdiskCluster_e - parse_RamdiskCluster;correct cx
        add     bx, cx
        mov     cx, bx

        test    status_flag, flag_found_RamdiskCluster          ; 
        jz      .correct_is_not_set_RamdiskCluster

;       mov     si,found_equal_timeout                          ;     , 
;       call    printplain
;       jmp     .get_next_str

.correct_is_not_set_RamdiskCluster:
        mov     ax, 0x3d20         ;cut al=' ' ah='='
        repe scasb
        jcxz    .end_get_RamSC_ERROR_1          ;not found param 
        
        cmp     ah, byte [es:di-1]   ;find '='
        jnz     .start_RamdiskCluster                   ;         
        
        repe scasb                 ;cut ' '
        inc     cx
        dec     di
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
@@:
        movzx   ax, byte [es:di]
        cmp     al, '0'
        jb      .end_RamdiskCluster
        cmp     al, '9'
        ja      .end_RamdiskCluster
;;;;;;;;;;;;;;;;;;;
        xor     al, 0x30

        jmp     .end_RamdiskCluster


.RamdiskCluster_rest_val:
        mov     cx, bx
        mov     di, ax
        jmp     .start_RamdiskCluster
.end_get_RamSC_ERROR_1:

.end_RamdiskCluster:
if DEBUG
        pusha
        mov     cx, 0x0a
        mov     di, RamdiskCluster_msg
;        mov     word[ds:di],'  '
        call    decode
;Show size
        mov     si, RamdiskCluster_msg
        call    printplain

        popa
end if  

}

macro use_Loader_Image
;     1 .
;     1.44 
{
local .start_p_LI
local .exit
local .error_LI
local .rest_value_loop
local .found_end_str
        mov     di, point_default  ;restore value
        mov     cx, save_cx_d
;   LoaderModule=kord/kolibri.ldm
.start_p_LI:
        call    get_firs_sym    ;get first symbol on new line
        test    cx, cx
        jz      .exit   ;?   -    ) 
        cmp     al, 'L'
        jnz     .start_p_LI
;   LoaderModule
;        parse_LoaderModule
        mov     bx, cx
        mov     ax, di

        mov     si, parse_LoaderImage
        mov     cx, parse_LoaderImage_e - parse_LoaderImage
        repe cmpsb
        jnz     .rest_value_loop           ;is not compare

        sub     bx, parse_LoaderImage_e - parse_LoaderImage;correct cx
        add     bx, cx
        mov     cx, bx

;       test    status_flag,flag_found_LM               ; 
;       jz      .correct_is_not_set_LI          

;       mov     si,found_equal_timeout                          ;     , 
;       call    printplain
;       jmp     .get_next_str

;.correct_is_not_set_LI:
        mov     ax, 0x3d20         ;cut al=' ' ah='='
        repe scasb
        jcxz    .rest_value_loop_LI          ;not found param timeout
        
        cmp     ah, byte [es:di-1]   ;find '='
        jnz     .rest_value_loop_LI
        
        repe scasb                 ;cut ' '
        inc     cx
        dec     di
;di     ,  cx    .
;     .
;     ,  callback 
;  -  dd       byte =0
;  :  ini    LoaderModule = kord/kernel.loader
;            dw,dw,db'kord/kernel.loader',0       
;  2 word
        push    dword [es:di-6]
        lea     si, [di-6]

        push    word [es:di-2]
        xor     ax, ax
        mov     word [es:di-6], ax      ;  
;info_real_mode_size         
        mov     ax, info_real_mode_size ;0x3000   ;   


        mov     word [es:di-4], ax
        mov     word [es:di-2], 16      ;-   4  =64  ..    
;;;;;;   
@@:
        mov     al, byte [es:di]
        cmp     al, ' '
        jz      .found_end_str
        cmp     al, 0xa
        jz      .found_end_str
        cmp     al, 0xd
        jz      .found_end_str
        inc     di
        dec     cx
        jnz     @b
;;;not found ,          
.found_end_str:
;    64        1 .
        push    word [es:di]
        xor     ax, ax
        mov     word [es:di], ax
;        xor     ax,ax   ; function 1 - read file
        mov     di, si  ;file_data
        inc     ax
        push    si
        push    es
        call    far dword [loader_callback]
        push    cs
        pop     ds

        pop     es
        pop     si

        test    bx, bx
        jnz     .error_LM


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    64   1 .
        mov     si, table_15_87
        push    es
        push    ds
        pop     es
        mov     cx, 256*18
        mov     ah, 0x87
        int     0x15
        pop     es
        pop     dx cx
        test    ah, ah



        jmp     far dword [es:si]




.rest_value_loop:
        mov     di, ax
        mov     cx, bx
        jmp     .start_p_LI

.exit:



}



macro name_in_root_fat
;,          
{

}



macro use_RamdiskFile
{
;    callback   
;       , ..   
;   087  int 0x15  -     64   1 
local   .start_loop
local   ._end
local   .rest_value_loop
local   .error
        mov     di, point_default  ;restore value
        mov     cx, save_cx_d
        mov     data_offset, 0  ;clean offset
;   LoaderModule=kord/kolibri.ldm
.start_loop:
        call    get_firs_sym    ;get first symbol on new line
        test    cx, cx
        jz      ._end   ;?   -    ) 
        cmp     al, 'R'
        jnz     .start_loop
;   RamdiskFile
        mov     bx, cx
        mov     ax, di

        mov     si, parse_RamdiskFile
        mov     cx, parse_RamdiskFile_e - parse_RamdiskFile
        repe cmpsb
        jnz     .rest_value_loop           ;is not compare

        sub     bx, parse_RamdiskFile_e - parse_RamdiskFile;correct cx
        add     bx, cx
        mov     cx, bx
;       test    status_flag,flag_found_LM               ; 
;       jz      .correct_is_not_set_LM          

;       mov     si,found_equal_timeout                          ;     , 
;       call    printplain
;       jmp     .get_next_str

;.correct_is_not_set_LM:
        mov     ax, 0x3d20         ;cut al=' ' ah='='
        repe scasb
        test    ecx, ecx
        jz      .rest_value_loop   ;not found param timeout
        
        cmp     ah, byte [es:di-1] ;find '='
        jnz     .rest_value_loop
        
        repe scasb                 ;cut ' '
        inc     cx
        dec     di

        mov     save_di_RAMDISK, di
        mov     save_cx_RAMDISK, cx
;di     ,  cx    .
;     .
;     ,  callback 
;  -  dd       byte =0
;  :  ini    RamdiskFile = @menu,@menu
;            dw,dw,db'@menu',0       
;  2 word

;
@@:
        mov     al, byte [es:di]
        cmp     al, ','         ; ..   
        jz      .found_end_str
        inc     di
        dec     cx
        jnz     @b
;;;not found ,          
.found_end_str:
;        mov    al,byte [es:di]
;       cmp     al,' '          ;  ,   
;       jnz     @f
;       inc     di
;       dec     cx
;       jnz     .found_end_str

;@@:
        mov     point_to_dest_file_name, di
        inc     di
;   
check_name_file
;/restore di - point and cx -size section
        mov     di, save_di_RAMDISK
        mov     cx, save_cx_RAMDISK

        test    al, al
        jnz     .start_loop     ;  al   =0,       .



        push    dword [es:di-6]
        lea     si, [di-6]

        push    word [es:di-2]
        push    di
        xor     ax, ax
        mov     word [es:di-6], ax      ;  
;info_real_mode_size         
        mov     ax, info_real_mode_size ;0x3000   ;   


        mov     word [es:di-4], ax
        mov     word [es:di-2], 16      ;-   4  =64  ..    

        mov     di, point_to_dest_file_name

if DEBUG
        pushad
;       mov     ax,di
        mov     cx, 0x0a
        mov     di, name_of_seg_get_64
        mov     dword[ds:di], '    '
        mov     word[ds:di+4], '  '
        call    decode
;Show size
        mov     si, name_of_seg_get_64
        call    printplain

        popad
end if  

        push    word [es:di]
        push    cx
        xor     ax, ax
        mov     word [es:di], ax
;        xor     ax,ax   ; function 1 - read file
        push    di
        mov     di, si  ;file_data
        inc     ax
        push    si
        push    es
        push    bp

        push    es
        pop     ds
        push    cs
        pop     es

        call    far dword [es:loader_callback]


        push    cs
        pop     ds

        pop     bp
        pop     es
        pop     si

        cmp     bx, 2
        ja      .error
;     dx:ax  ,   .
;  ,   bx=1 ..      
        mov     status_flag_loader_f, bx

        shl     edx, 16
        mov     dx, ax
;       shr     edx,10  ;   .
;; edx   .        
        mov     save_file_size, edx
        mov     eax, edx
;   
        pop     di
        pop     cx      ;   2-   ..   .
        pop     word [es:di]
        pop     di
        pop     word [es:di-2]
        pop     dword [es:di-6]
        

if DEBUG
        pushad
        mov     cx, 0x0a
        mov     di, RamdiskFile_msg
        mov     dword[ds:di], '    '
        call    decode
;Show size
        mov     si, RamdiskFile_msg
        call    printplain

        popad
end if  










;      
;       mov     ax,word [fat12_buffer.BPB_BytsPerSec] ;-       512 1024 2048 4096 2 
;       movzx   bx,byte [fat12_buffer.BPB_SecPerClus] ;-   
;       imul    ax,bx
;  eax   (512) 
; edx      64     
;   1 
;1      ..   ,     

;      
register_file_in_fat
;  1   
move_file_up

;,     ? ..      64 ,     
        cmp     status_flag_loader_f, 0x1
        jnz     @f
;        1-     









@@:
;        
        mov     di, save_di_RAMDISK
        mov     cx, save_cx_RAMDISK
if DEBUG        
        pusha
        xor     ax, ax
        int     0x16
        popa
end if  


        jmp     .start_loop


.error:
        ;call   error.LoaderModule
;fixme!
.rest_value_loop:
        mov     di, ax
        mov     cx, bx
        jmp     .start_loop

._end:
;  1-     
move_up_fat_and_root_d






;  
;       mov     ah,0x87
;       mov     cx,     ;size in byte
        

;es:si point to descripts


}

macro use_BPB_RAM ;   512   1- 
;   BPB  ..  512 ,   12  1 
{
        mov     ax, fat12_buffer
        mov     si, table_15_87
        add     word [si+8*2+2], ax
        push    es
        push    ds
        pop     es
        mov     cx, 256  ;     512  512/2=256
        mov     ah, 0x87
        int     0x15
        pop     es
;add 512 byte for destination adress
;       add     dword [si+8*3+2], 512
;        test    ah, ah
;        jz     
if DEBUG        
        pusha
        mov     ax, word [si+8*2+2]
        mov     cx, 0x0a
        mov     di, BPB_msg
        call    decode
;Show size
        mov     si, BPB_msg
        call    printplain
        popa
end if  
}
macro first_create_fat_table
;    3   fat ,      ,   0 
;    .
{
        mov     al, byte [fat12_buffer.BPB_Media]


        push    ds


        mov     di, info_real_mode_size
        add     di, 0x1000

if DEBUG
        pushad

        mov     ax, info_real_mode_size
        add     ax, 0x1000
;       mov     ax,ds
        mov     cx, 0xa
               
        mov     di, first_entry_in_fat
        mov     dword [di], '    '
        mov     word [di+4], '  '
        call    decode
;Show size
        mov     si, first_entry_in_fat
        call    printplain

        xor     ax, ax
        int     0x16
      
        popad
end if


        push    di   ;  push    word info_real_mode_size+0x1000   ;c    
        
        xor     di, di
        mov     point_to_free_root, di  ;  =0      

        pop     ds   ;    ..  

        mov     byte [di], al
        or      ax, -1
        inc     di
        mov     word [di], ax

        pop     ds
        mov     point_next_fat_str, 3

if DEBUG        
        pushad
        mov     ax, point_next_fat_str
        mov     cx, 0x0a
        mov     di, fat_create_msg
        call    decode
;Show size
        mov     si, fat_create_msg
        call    printplain
        popad
end if  

}
macro register_file_in_fat
;      Fat
;   12,  )) 
;       fat/
{
local   .step2
local   .step3
local   .end
local   .eof_file

;di point on root dir   .
        push    es

        mov     ax, info_real_mode_size
        add     ax, 0x1000
        mov     es, ax ;        push    word info_real_mode_size+0x1000   ;      64 

;      ,    12 
; 12 ,    . 
        mov     di, firstDataSect    ; 
        sub     di, size_root_dir
;  ax      
        shl     di, 9;imul 512
        add     di, point_to_free_root  ;    32- .
;      .. 32 
if DEBUG        
        pushad
;       mov     ax,point_default
;        mov     ax,
        mov     cx, 0x0a
        mov     di, show_db2
        mov     dword[ds:di], '    '
        mov     word [ds:di+4], '  '
        call    decode
;Show size
        mov     si, show_db2
        call    printplain
;
;       xor     ax,ax
;       int     0x16
        popad
end if  



;gs:di -            .
        mov     si, shot_name_fat
        mov     cx, 11
;   
@@:
        lodsb
        stosb
        loop    @b

;    DIR_NTRes -   =0
        xor     ax, ax
        mov     ah, ATTR_VOLUME_ID
        mov     word [es:di], ax
        add     di, 2
;DIR_CrtTimeTenth
        mov     byte [es:di], 100
        inc     di
;DIR_CrtTime
        mov     word [es:di], 0x032b   ;
        add     di, 2
;DIR_CrtDate
        mov     word [es:di], 0x0      ; ><
        add     di, 2
;DIR_LstAccDate
        mov     word [es:di], 0x032b   ; 
        add     di, 2
;DIR_FstClusHI
        mov     word [es:di], 0x0      ;  12 /16  0
        add     di, 2
;DIR_WrtTime
        mov     word [es:di], 0x0      ; ><
        add     di, 2
;DIR_WrtDate
        mov     word [es:di], 0x032b
        add     di, 2
        
        mov     ax, point_next_fat_str
        mov     word [es:di], ax
        add     di, 2

        push    di
;DIR_FstClusLO                      .
 ;       mov     ax,point_next_fat_str   ;      ..    
;FATOffset = N + (N / 2) ..         -   3-   
        mov     bx, ax
        shr     bx, 1
        add     ax, bx
;   FATOffset
;ThisFATEntOffset = BPB_ResvdSecCnt + (FATOffset / BPB_BytsPerSec);
        mov     bx, word [fat12_buffer.BPB_BytsPerSec]
        cwd
        idiv    bx
;ax=ThisFATEntOffset= rem (FATOffset / BPB_BytsPerSec)    .
        mov     si, ax
;            .
;  . 
        movzx   eax, word [fat12_buffer.BPB_BytsPerSec]
        movzx   ebx, byte [fat12_buffer.BPB_SecPerClus]
        imul    eax, ebx
;ax -  .
;          .       
;     ,          .   
        mov     ebx, save_file_size     ;   
        
@@:
        sub     ebx, eax
        cmp     ebx, eax
        jbe     .eof_file

        inc     point_next_fat_str
        mov     cx, point_next_fat_str  ;      ..    
;FATOffset = N + (N / 2) ..         -   3-   
        mov     dx, ax
        shr     dx, 1
        add     cx, dx



        test    si, 0x1
        jz      .step2
        shl     cx, 4
        mov     word[es:si], cx
        inc     si
        add     cx, ax
        jmp     @b

.step2:
        and     cx, 0x0FFF
        mov     word[es:si], cx
        inc     si
        add     cx, ax
        jmp     @b

.eof_file:
        mov     cx, 0x0fff
        test    si, 0x1
        jz      .step3
        shl     cx, 4
        mov     word[es:si], cx
        jmp     .end

.step3:
        and     cx, 0x0FFF
        mov     word[es:si], cx

.end:
        inc     point_next_fat_str

        pop     di
;DIR_FileSize 32- DWORD     .
        mov     eax, save_file_size
        mov     dword [es:di], eax

if DEBUG        
        pushad

        mov     di, firstDataSect    ; 
        sub     di, size_root_dir
;  ax      
        shl     di, 9;imul 512
        add     di, point_to_free_root  ;    32- .

        push    di

        mov     si, dest_name_fat
        mov     cx, 11

;   
@@:
        mov     al, byte [es:di]
        inc     di
        mov     byte [ds:si], al
        inc     si
        loop    @b
        
        mov     di, si
        inc     di
        pop     ax
        mov     cx, 0xa
        call    decode

        mov     si, dest_name_fat
        call    printplain
        popad

END IF





        add     point_to_free_root, 32  ;    .
        pop     es

}





macro get_firstDataSector
;      ..    
; FirstDataSector = BPB_ResvdSecCnt + (BPB_NumFATs * FATSz) + RootDirSectors;
{
        mov     ax, word [fat12_buffer.BPB_FATSz16]
        movzx   bx, byte [fat12_buffer.BPB_NumFATs]
        imul    ax, bx  ;9x1=9
;ax=BPB_NumFATs * FATSz
        mov     bx, word [fat12_buffer.BPB_RootEntCnt]  ; count of 32-byte dir. entries (224*32 = 14 sectors= 7 kb)
        shr     bx, 4   ;imul bx,32 and then div 512 -> in bx size in sectors
        add     ax, bx  ;9+14=23
        mov     size_root_dir, bx
        movzx   bx, byte [fat12_buffer.BPB_RsvdSecCnt]  ;add 1 for fat 16/12
        add     ax, bx
;ax=firstDataSector -      0   . -  = 24 
        mov     firstDataSect, ax       ;  
;        ,        
        mov     bx, word [fat12_buffer.BPB_TotSec16]
        sub     bx, ax
        mov     ax, bx
        movzx   bx, byte [fat12_buffer.BPB_SecPerClus]
        cwd
        idiv    bx
        mov     DataClasters, ax

if DEBUG        
        pushad
        mov     ax, firstDataSect       ;  
        mov     cx, 0x0a
        mov     di, firstDataSect_msg
        call    decode
;Show size
        mov     si, firstDataSect_msg
        call    printplain
;;;;;;;;;;;;;;;;;;;;;;;;;;
        mov     ax, size_root_dir       ;    
        mov     cx, 0x0a
        mov     di, size_root_dir_msg
        call    decode
;Show size
        mov     si, size_root_dir_msg
        call    printplain
;;;;;;;;;;;;;;;;;;;;;;;;;;
        mov     ax, DataClasters;
        mov     cx, 0x0a
        mov     di, DataClasters_msg
        call    decode
;Show size
        mov     si, DataClasters_msg
        call    printplain
        popad

end if  

}

macro use_RamdiskPATHS
;   .
{

}

macro use_RamdiskPATHD
;   .
{

}
macro check_name_file
;    ,    .
; : es-       .. startos.ini
;di -     .. es:di     
;  eax =-1  , eax=0   .
{
local   .no_equal
local   .exit
local   .loop_size_root_dir
;    ,       .
;        
        convertion_file_name    ;     
        test    ax, ax
        jnz     .exit

        lea     si, [shot_name_fat]     ; desination name of file

;    
        mov     di, firstDataSect
        sub     di, size_root_dir
;  ax      
        shl     di, 9;imul 512
;di=        .   64 .
;  - .. - ,    .
        mov     dx, root_dir_entry_count
        
        mov     ax, info_real_mode_size
        add     ax, 0x1000


        mov     gs, ax
.loop_size_root_dir:
DEBUG1 equ 0
if DEBUG1        
        pushad
        push    di
        mov     eax, dword[gs:di]
        lea     si, [check_root_fat_+14]
        mov     dword [ds:si], '----'
        mov     dword [ds:si+4], '----'
        mov     dword [ds:si+8], '----'
        mov     dword[ds:si], eax
        mov     eax, dword[gs:di+4]
        mov     dword[ds:si+4], eax
        mov     eax, dword[gs:di+8]
        mov     dword[ds:si+8], eax

;
        xor     eax, eax
        mov     ax, gs;point_next_fat_str
        mov     cx, 0x0a
        mov     di, check_root_fat_
        mov     dword [di], '    '
        mov     word [di+4], '  '
        call    decode
        xor     eax, eax
        pop     ax
        mov     di, (check_root_fat_+7)
        mov     dword [di], '    '
        mov     word [di+4], '  '
        call    decode

;Show size
        lea     si, [check_root_fat_]
        call    printplain

        lea     si, [shot_name_fat]
        call    printplain

        xor     ax, ax
        int     0x16
        popad
end if  

        xor     bx, bx
        mov     cx, 11  ;size of name in struct FAT

@@:     
        mov     al, byte [ds:si+bx]     ;ds:si - point to name of convertion variable.
        mov     ah, byte [gs:di+bx]     ;gs:di - point to name in fat struct
        inc     bx

if DEBUG
;        pushad
;        lea    si,[check_root_fat_+14]
;        mov     dword [ds:si],'----'
;        mov    word [ds:si],ax
;       call    printplain

;       xor     ax,ax
;       int     0x16

;        popad
end if



        cmp     ah, al
        jnz     .no_equal

;       dec     cx
;       jnz     @b
        loop    @b

;.succesfuly:
;,     :(
        or      ax, -1
        jmp     .exit


.no_equal:
        add     di, 32          ;fat struct =32 byte
        dec     dx
        jnz     .loop_size_root_dir

;.exit_check_name:
        and     ax, 0

.exit:

if DEBUG        
        pushad
;Show size
        lea     si, [check_name_fat_msg_n]
        test    ax, ax
        jz      @f
        lea     si, [check_name_fat_msg_y]
        call    printplain
        lea     si, [alarm_msg]
@@:
        call    printplain
        popad
end if  

}


macro convertion_file_name
;  ,              
;   hello.asm  'HELLO   ASM',     fat.
;  es:di       ,   shot_name_fat
{
local   .next_step
local   .error
local   .st1
local   .st2
local   .st2_l
local   .st3
local   .st4_s
local   .st4
local   .st5

;    ,       .
;       mov     di,point_to_dest_file_name    
        mov     si, shot_name_fat
        or      first_input, -1 ;    
        mov     cx, 11  ;     

@@:     
        mov     al, byte [es:di]
        cmp     al, 0xa
        jz      .st4_s
        cmp     al, 0xd
        jz      .st4_s
        cmp     al, 0x20
        jz      .st4_s

        cmp     al, 0x20
        jb      .error
        cmp     al, 0x22
        jz      .error
        cmp     al, 0x2a
        jz      .error
        cmp     al, 0x2b
        jz      .error
        cmp     al, 0x2c
        jz      .error
        cmp     al, 0x2F
        jz      .error

        cmp     al, 0x3a
        jz      .error
        cmp     al, 0x3b
        jz      .error
        cmp     al, 0x3c
        jz      .error
        cmp     al, 0x3d
        jz      .error
        cmp     al, 0x3E
        jz      .error
        cmp     al, 0x3F
        jz      .error

        cmp     al, 0x5b
        jz      .error
        cmp     al, 0x5c
        jz      .error
        cmp     al, 0x5d
        jz      .error

        cmp     al, 0x7c
        jz      .error

        
        cmp     first_input, -1
        jnz     .next_step
        and     first_input, 0  ; .
        cmp     al, '.'
        jz      .error  ; ,      

.next_step:
        cmp     al, 0x2e
        jnz     .st2            ; ,   
;    
;    
        mov     al, ' '

;!fixme     :(
        cmp     cl, 3   ;   GIDGIDIIASM .. gidgidii.asm
        jbe     .st2


.st3:   
        mov     byte [si], al
        inc     si
        dec     cx
        cmp     cx, 3
        ja      .st3
;       inc     cx
        inc     di
        jmp     @b

.st2:
        cmp     al, 0x60
        jbe     .st2_l
        
        xor     al, 0x20;  
.st2_l:
        mov     byte [si], al
        inc     di
        inc     si
;        dec    cx
;       jnz     @b
        loop    @b
.st5:
        xor     ax, ax
        jmp     @f

;;;;;;;; ,      
.st4_s:
        mov     al, ' '
.st4:
        mov     byte [si], al
        inc     si
        loop    .st4
        jmp     .st5

.error:
        or      ax, -1
@@:

if DEBUG        
        pushad
        
        mov     si, convertion_file_name_msg_y
        test    ax, ax
        jz      @f
        mov     si, convertion_file_name_msg_n
@@:
        call    printplain

        mov     si, shot_name_fat
        mov     byte [si+12], 0
        call    printplain
        popad

end if  
}

macro move_file_up
;    1      .
{
local   .st1
local   .correct_on_byte
;   ,  BPB    1 , ,      ,
;    ,     
;       

        mov     ax, info_real_mode_size ;    
        mov     si, table_15_87
        mov     word [si+8*2+2], ax
;     1- 
        movzx   eax, firstDataSect
        movzx   edx, data_offset
        add     eax, edx

        movzx   ebx, word [fat12_buffer.BPB_BytsPerSec]
        movzx   edx, byte [fat12_buffer.BPB_SecPerClus]
        imul    bx, dx  ;  



        push    ebx     ;save bx

        imul    eax, ebx
;       shl     eax,9   ;  512
        
if DEBUG
        pushad
        xor     eax, eax
        mov     ax, info_real_mode_size
        mov     cx, 0x0a
        mov     di, seg_where_get_data
        mov     dword [di], '    '
        mov     word [di+4], '  '
        call    decode
;Show size
        mov     si, seg_where_get_data
        call    printplain
        popad

end if

;       mov     bx,word [fat12_buffer.BPB_BytsPerSec] 
;       movzx   dx,byte [fat12_buffer.BPB_SecPerClus]
;       imul    bx,dx
;       cwd
;       idiv    bx

        mov     dl, 0x10

@@:
        cmp     eax, 0x00010000
        jb      @f

        sub     eax, 0x00010000
        inc     dl
        jmp     @b


@@:
        mov     byte [si+8*3+3], dl     ; 
        mov     word [si+8*3+2], ax

        mov     ecx, save_file_size     ;   .
        cmp     ecx, 0x0000ffff         ;  .. 64 
        jbe     .correct_on_byte        ;   



        mov     ecx, 0x00010000         ;65536 
        sub     save_file_size, ecx     ;
;       jmp     .st1                    ; 08000




;       
.correct_on_byte:
;/  
        pop     eax     ;restore size of claster
        push    ecx
@@:
        inc     data_offset

        cmp     eax, ecx
        jae     @f
        sub     ecx, eax
        jmp     @b
@@:
        pop     ecx




        test    ecx, 0x1
        jz      .st1
        inc     ecx
.st1:
        shr     ecx, 1    ;    0x87 function

;   1         
        push    es
        push    ds
        pop     es

        mov     ah, 0x87
        int     0x15
        pop     es

if DEBUG
        pusha
;       mov     ax,point_next_fat_str
        mov     cx, 0x0a
        mov     di, return_code_af_move
        call    decode
;Show size
        mov     si, return_code_af_move
        call    printplain
        popa

end if

}


macro move_up_fat_and_root_d
;,     1         
{
local  .st1

        mov     ax, info_real_mode_size
        add     ax, 0x1000

        mov     si, table_15_87
        mov     word [si+8*2+2], ax
;  
        mov     ax, 512
        mov     word [si+8*3+2], ax
;fixme!     ..       .

        movzx   ecx, word [fat12_buffer.BPB_FATSz16]
        movzx   bx, byte [fat12_buffer.BPB_NumFATs]
        imul    cx, bx  ;9x1=9

        add     cx, size_root_dir       ;  
        shl     ecx, 9  ;imul 512


; 
        test    ecx, 0x1
        jz      .st1
        inc     ecx
.st1:
        shr     ecx, 1

        push    es
        push    ds
        pop     es

        mov     ah, 0x87
        int     0x15
        pop     es

if DEBUG
        pusha
;       mov     ax,point_next_fat_str
        mov     cx, 0x0a
        mov     di, return_code_af_fat_m
        call    decode
;Show size
        mov     si, return_code_af_fat_m
        call    printplain
        popa

end if

}
